// countWords.cpp
#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <sstream>
#include <random>
#include <Eigen/Dense>
#include <Eigen/Sparse>
#include "commonDoc.h"
using namespace Eigen;
using namespace std;
int main(int argc, char* argv[]){
  string fname = argv[1];
  ifstream ifile( fname );
  int nRows = 0, nCols = 0; // 行数（ndim）と列数（文書数）を表す変数の宣言
  int row, col;
  double val;
  string buf;
  typedef Triplet<double> T;
  vector<T> triplets;
  while( getline(ifile,buf) ){
    istringstream iss(buf);
    iss >> row >> col >> val;
    triplets.emplace_back(T(row-1,col-1,val));
    if( row > nRows ) nRows = row;
    if( col > nCols ) nCols = col;
  }
  ifile.close();
  int ndim = nRows;
  int nvec = nCols;
  spCMat spX(ndim,nvec);
  spX.setFromTriplets(triplets.begin(), triplets.end());
  //-- クラスタラベル読み込み
  string fnameC = argv[2]; 
  ifstream ifileC( fnameC );
  vector<int> vecC;
  while( getline(ifileC,buf) ) vecC.emplace_back(stoi(buf)-1);
  vector<string> word;
  vector<double> freq(ndim,0);
  //-- 単語List読み込み
  string fnameVoca = argv[3];
  ifile.open(fnameVoca);
  while( ifile >> buf ) word.emplace_back(buf);
  ifile.close();
  int id = 0;
  int k = stoi( argv[4] )-1; //-- 注目するクラスタの指定
  //-- 特定クラスタの単語数のカウント
  for( int i = 0 ; i < nvec ; i++ )
    if( vecC[i] == k )
      for( SparseMatrix<double>::InnerIterator it(spX,i);it; ++it)
        freq[it.row()] += it.value();
  for( int m = 0 ; m < ndim ; m++ )
    cout << word[m] << " " << freq[m] << endl;
}
