// genPunch.cpp
#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <sstream>
#include <random>
using namespace std;
int main(int argc, char* argv[]){
  string fnameRatio = argv[1];
  string fnamePrior = argv[2];
  int nvec          = stoi(argv[3]); // ボウル数＝ベクトル数N
  int nFruits       = stoi(argv[4]); // １つのボウルのために生成する果物数
  int seed          = stoi(argv[5]); // 乱数の種
  string buf;
  vector<vector<double>> RatioVecs;  // 果物が出現する条件付き確率を格納
  ifstream ifileRatio( fnameRatio );
  while( getline(ifileRatio,buf) ){
    istringstream iss(buf);
    vector<double> vec;
    double d;
    while( iss >> d ) vec.emplace_back(d);
    RatioVecs.emplace_back(vec);
  }
  ifileRatio.close();
  int numc = RatioVecs.size();    // クラス数K(numc)＝壺の数
  int ndim = RatioVecs[0].size(); // 特徴数M(ndim)＝果物の種類数
  vector<double> Prior(numc,0);   // 事前確率（クラス数（壺数）ある）
  ifstream ifilePrior( fnamePrior );
  for( int k = 0 ; k < numc ; k++ ) ifilePrior >> Prior[k];
  ifilePrior.close();

  mt19937 gen(seed);
  discrete_distribution<size_t> distPot(Prior.begin(),Prior.end());
  for( int i = 0 ; i < nvec ; i++ ){
    //-- クラス（壺）の選択
    int Ck = distPot(gen);
    //-- 特徴（＝果物）の選択と出力
    discrete_distribution<size_t> distFruits(RatioVecs[Ck].begin(),
                                             RatioVecs[Ck].end());
    for( int j = 0 ; j < nFruits ; j++ ){
      int Wm = distFruits(gen);
      if( j != nFruits - 1 ) cout << Wm << " ";
      else                   cout << Wm;
    }
    cout << "," << Ck << endl;
  }
}
