// reallocateDocId.cpp
#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <set>
#include <sstream>
#include <Eigen/Dense>
#include <Eigen/Sparse>
using namespace Eigen;
using namespace std;
int main(int argc, char* argv[]){
  string fname   = argv[1]; // 文書疎行列（3つ組）ファイル
  string fnameC  = argv[2]; //（クラスラベル）ファイル入力
  string fnameC2 = argv[3]; //（クラスラベル）ファイル出力
  int nRows = 0, nCols = 0; // 行数（ndim）と列数（文書数）を表す変数の宣言
  int row, col;
  double val;
  string buf;
  set<int> validDocIds;     // 0始まり．有効な文書idの集合
  typedef Triplet<double> T;
  vector<T> triplets;
  ifstream ifile( fname );
  while( getline(ifile,buf) ){
    istringstream iss(buf);
    iss >> row >> col >> val;
    triplets.emplace_back(T(row-1,col-1,val));
    if( row > nRows ) nRows = row;
    if( col > nCols ) nCols = col;
    validDocIds.insert(col-1); // 文書idを有効な文書id集合に追加
  }
  ifile.close();
  int ndim = nRows;    // 行数は，単語種類数（特徴の次元数ndim=M）を表す
  int nvec = nCols;    // 列数は，文書数nvec=Nを表す
  SparseMatrix<double> spX(ndim,nvec);
  spX.setFromTriplets(triplets.begin(), triplets.end());
  ifstream ifileC( fnameC );
  vector<int> vecC;
  while( getline(ifileC,buf) ) vecC.emplace_back(stoi(buf)-1);
  ifileC.close();
  int Did = 0;
  ofstream ofileClass( fnameC2 );
  for( int i = 0 ; i < nvec ; i++ ){          // すべての文書idについて
    if( validDocIds.find(i) != validDocIds.end() ){ // 有効な文書idなら
      ofileClass << vecC[i]+1 << endl;
      for(SparseMatrix<double>::InnerIterator it(spX,i);it; ++it)
        cout << it.row()+1 << " " << Did+1 << " " << it.value() << endl;
      Did++;
    }
  }
}
