// recomPurePearson1.cpp
#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <set>
#include <sstream>
#include <Eigen/Dense>
#include <Eigen/Sparse>
using namespace Eigen;
using namespace std;
int main(int argc, char* argv[]){
  string fname = argv[1];
  ifstream ifile( fname );
  int nRows = 0, nCols = 0; // 行数（User）と列数（item）を表す変数の宣言
  int row, col;
  double val;
  string buf;
  typedef Triplet<double> T;
  vector<T> triplets;
  while( getline(ifile,buf) ){
    istringstream iss(buf);
    iss >> row >> col >> val;
    triplets.emplace_back(T(row-1,col-1,val));
    if( row > nRows ) nRows = row;
    if( col > nCols ) nCols = col;
  }
  ifile.close();
  int nItems = nCols;
  int nUsers = nRows;
  double nUInv = 1.0 / (double) nUsers;
  SparseMatrix<double> spX(nUsers,nItems);
  spX.setFromTriplets(triplets.begin(), triplets.end());
  VectorXd mu(nItems);
  for( int i=0; i<nItems; i++ ) mu(i) = ((VectorXd) spX.col(i)).mean();
  VectorXd A(nItems);
  for( int i = 0 ; i < nItems ; i++ ){
    double val = nUInv*((VectorXd)spX.col(i)).squaredNorm()-mu(i)*mu(i);
    if( val > 0 ) A(i) = 1.0 / sqrt(val);
  }
  //-- 各アイテムに対し，相関が高いアイテムを相関係数の値の降順に出力
  for( int i = 0 ; i < nItems ; i++ ){
    cout << i+1;
    multimap<double, int, greater<double> > mapP2itemId;// 降順整列用    
    MatrixXd iXX = nUInv * spX.col(i).transpose() * spX;
    for( int j = 0 ; j < nItems ; j++ ){
      if( j != i ){
        double corr = A(i)*A(j) * (iXX(j) - mu(i)*mu(j));
        mapP2itemId.insert(pair<double, int>(corr,j));
      }
    }
    multimap<double, int>::iterator it = mapP2itemId.begin();
    for( int j = 0 ; j < 3 ; it++, j++ ) cout << " " << it->second+1;
    cout << endl;
  }
}
